config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

config etc/cron.d/sogo.new
preserve_perms etc/cron.daily/sogo.new
config etc/httpd/extra/httpd-sogo.conf.new
config etc/logrotate.d/sogo.new
preserve_perms etc/rc.d/rc.sogod.new
config etc/sogo/sogo.conf.new
config etc/sysconfig/sogo.new
( cd usr/include ; rm -rf SOGo )
( cd usr/include ; ln -sf ../lib64/GNUstep/Frameworks/SOGo.framework/Headers SOGo )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework ; rm -rf Headers )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework ; ln -sf Versions/Current/Headers Headers )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework ; rm -rf Resources )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework ; ln -sf Versions/Current/Resources Resources )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework/Versions/5/sogo ; rm -rf SOGo )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework/Versions/5/sogo ; ln -sf libSOGo.so SOGo )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework/Versions/5/sogo ; rm -rf libSOGo.so )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework/Versions/5/sogo ; ln -sf libSOGo.so.5 libSOGo.so )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework/Versions/5/sogo ; rm -rf libSOGo.so.5 )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework/Versions/5/sogo ; ln -sf libSOGo.so.5.0.1 libSOGo.so.5 )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework/Versions ; rm -rf Current )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework/Versions ; ln -sf 5 Current )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework/sogo ; rm -rf SOGo )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework/sogo ; ln -sf ../Versions/Current/sogo/SOGo SOGo )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework/sogo ; rm -rf libSOGo.so )
( cd usr/lib64/GNUstep/Frameworks/SOGo.framework/sogo ; ln -sf ../Versions/Current/sogo/libSOGo.so libSOGo.so )
( cd usr/lib64/sogo ; rm -rf libGDLContentStore.so )
( cd usr/lib64/sogo ; ln -sf libGDLContentStore.so.4.9 libGDLContentStore.so )
( cd usr/lib64/sogo ; rm -rf libGDLContentStore.so.4.9 )
( cd usr/lib64/sogo ; ln -sf libGDLContentStore.so.4.9.0 libGDLContentStore.so.4.9 )
( cd usr/lib64/sogo ; rm -rf libNGCards.so )
( cd usr/lib64/sogo ; ln -sf libNGCards.so.4.9 libNGCards.so )
( cd usr/lib64/sogo ; rm -rf libNGCards.so.4.9 )
( cd usr/lib64/sogo ; ln -sf libNGCards.so.4.9.0 libNGCards.so.4.9 )
( cd usr/lib64/sogo ; rm -rf libSOGo.so )
( cd usr/lib64/sogo ; ln -sf ../GNUstep/Frameworks/SOGo.framework/Versions/Current/sogo/libSOGo.so libSOGo.so )
( cd usr/lib64/sogo ; rm -rf libSOGo.so.5 )
( cd usr/lib64/sogo ; ln -sf ../GNUstep/Frameworks/SOGo.framework/Versions/5/sogo/libSOGo.so.5 libSOGo.so.5 )
( cd usr/lib64/sogo ; rm -rf libSOGo.so.5.0.1 )
( cd usr/lib64/sogo ; ln -sf ../GNUstep/Frameworks/SOGo.framework/Versions/5/sogo/libSOGo.so.5.0.1 libSOGo.so.5.0.1 )
( cd usr/lib64/sogo ; rm -rf libSOGoUI.so )
( cd usr/lib64/sogo ; ln -sf libSOGoUI.so.5.0 libSOGoUI.so )
( cd usr/lib64/sogo ; rm -rf libSOGoUI.so.5.0 )
( cd usr/lib64/sogo ; ln -sf libSOGoUI.so.5.0.0 libSOGoUI.so.5.0 )
